/*     Bed a menu-driven multi dataformat binary editor for Linux            */
/*     Copyright (C) 1998 Jaap Korthals Altes <jkaltes@cyberbrain.com>       */
/*                                                                           */
/*     This program is free software; you can redistribute it and/or modify  */
/*     it under the terms of the GNU General Public License as published by  */
/*     the Free Software Foundation; either version 2 of the License, or     */
/*     (at your option) any later version.                                   */
/*                                                                           */
/*     This program is distributed in the hope that it will be useful,       */
/*     but WITHOUT ANY WARRANTY; without even the implied warranty of        */
/*     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         */
/*     GNU General Public License for more details.                          */
/*                                                                           */
/*     You should have received a copy of the GNU General Public License     */
/*     along with this program; if not, write to the Free Software           */
/*     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.             */
/* Fri Dec  8 22:14:27 2000                                                  */
#include "global.h" 
#include <stdlib.h>
#include "config.h"
#include CURSES_HEADER
#include <stdio.h>
#include <string.h>
#include "screenpart.h"
#include "screen.h"
#ifdef __CYGWIN__
#include "../../src/shell.h"
#endif
BEDPLUGIN
class Editor {
public:
#include "faked.h"
iscalled(editdata)
};

#ifdef __CYGWIN__
#include <sys/cygwin.h>
#endif

#ifdef _WIN32
#include <windows.h>
static char windir[MAX_PATH+10];
char *fullnotepad(void) {
	GetWindowsDirectory(windir,MAX_PATH);
	int len=strlen(windir);
	windir[len++]='\\';
	strcpy(windir+len,"notepad");
	return windir;
	}
#endif
extern int mytmpname(char *buf,int len,const char *name) ;

int  Editor::editdata(void) {
	static const char *editorname=(editorname=getenv("EDITOR"))?editorname: 
#ifdef _WIN32
fullnotepad();
#else
"vi"; 
#endif
#ifndef __CYGWIN__
	static char com[512];
	static const int ednamelen=(strcpy(com,editorname),strlen(editorname));
        char *tmpname=&com[ednamelen+1];
	com[ednamelen]=' ';
#else
	char tmpname[256];
#endif
#ifdef OLDTMP
#ifdef __CYGWIN__
	char tmpnamel[]="/tmp/bed-tmp-XXXXXX";
	mktemp(tmpnamel);
 cygwin32_conv_to_win32_path(tmpnamel,tmpname);

#else
	strcpy(tmpname,"/tmp/bed-tmp-XXXXXX");
#ifdef HAS_MKSTEMP
	mkstemp(tmpname);
#else
	mktemp(tmpname);
#endif
#endif
#else
if(mytmpname(tmpname,256,"bedtmp-XXXXXX")<0) {
	message("Failed to create to create temporary file");
	return -1;
	}
#endif	

	int lensel;
	int bytes=activemode()->bytes;
        OFFTYPE posf=getfilepos()+(geteditpos()/bytes)*bytes,first,last;
	OFFTYPE other=getselect();
        if(other>posf) {
                first=posf;
                last=other+bytes;
                if(last>filesize())
                        last-=bytes;
                lensel=last-first;
                if(lensel%bytes) {
                        first-=(bytes   -lensel%bytes);
                        if(first<0)
                                first+=bytes;
                        }
                }
        else {
                first=other;
                }
	int ret;
	if((ret=saveshownname(tmpname)) <0) {
		beep();
		switch(ret) {
			case -1: message("No selection");break;
			default: message("saveshowname failt");break;
			}
		return -1;
		}
#ifndef NOENDWIN
	if(!isendwin())
		endwin();
#else
	SHOWCURSOR;
#endif
#ifndef __CYGWIN__
	system(com);
#else
process(editorname,tmpname);
#endif
#ifndef PDCURSES
	wrefresh(stdscr);
#endif
	HIDECURSOR;

	topos(first);
	if(readshownname(tmpname) <0) {
		topos(posf);
#ifdef PDCURSES
rewrite();
#endif
		return -1;
		}
	topos(posf);
	remove(tmpname);
#ifdef PDCURSES
rewrite();
#endif
	message("Changes inserted");
	return 0;
	}

call(editdata)
